﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Reflection;
using System.Runtime.CompilerServices;
using Microsoft.CSharp.RuntimeBinder;

namespace ConsoleApplication1
{
    class Program
    {
        public static CallSite<Action<CallSite, object>> p__Site1;

        static void Main(string[] args)
        {
            try
            {
                dynamicTest();
            }
            catch { }

            SimpleReflection();

            StrongTypeCall(new Duck());
            StrongTypeCall(new Goose());

            string txt = "test func";
            List<int> list = new List<int> { 1, 2, 3, 4, 5 };

            Console.WriteLine(DuckTypingCall(txt, "test"));
            Console.WriteLine(DuckTypingCall(list, 3));
        }

        private static void SimpleReflection()
        {
            string txt = "Test Func";
            bool result = txt.Contains("Test");

            Type type = txt.GetType();
            MethodInfo containsMethodInfo = type.GetMethod("Contains");
            if (containsMethodInfo != null)
            {
                object returnValue = containsMethodInfo.Invoke(txt, new object[] { "Test" });
                bool callResult = (bool)returnValue;
            }

            {
                dynamic txt2 = "Test Func";
                bool result2 = txt2.Contains("Test");
                Console.WriteLine(result2);
            }

            {
                string mscorlib = "mscorlib, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089";
                Assembly asm = Assembly.Load(mscorlib);
                if (asm != null)
                {
                    dynamic d = asm.CreateInstance("System.Collections.Generic.List`1[[System.Int32, " + mscorlib + "]]");
                    d.Add(5);
                    d.Add(6);

                    foreach (var item in d)
                    {
                        Console.WriteLine(item);
                    }
                }
            }

        }

        private static void dynamicTest()
        {
            //dynamic d = 5;
            //d.CallTest();

            // 위의 2 라인은 다음과 같이 확장되어 컴파일 된다.
            object d = 5;
            if (p__Site1 == null)
            {
                p__Site1 = CallSite<Action<CallSite, object>>.Create(
                    Microsoft.CSharp.RuntimeBinder.Binder.InvokeMember(CSharpBinderFlags.ResultDiscarded, "CallTest", null, typeof(Program),
                    new CSharpArgumentInfo[] { CSharpArgumentInfo.Create(CSharpArgumentInfoFlags.None, null) }));
            }
            p__Site1.Target(p__Site1, d);
        }

        private static void StrongTypeCall(IBird bird)
        {
            bird.Fly();
        }

        private static int DuckTypingCall(dynamic target, dynamic item)
        {
            return target.IndexOf(item);
        }

    }

    interface IBird
    {
        void Fly();
    }

    class Duck : IBird
    {
        public void Fly()
        {
            Console.WriteLine("Duck fly");
        }
    }

    class Goose : IBird
    {
        public void Fly()
        {
            Console.WriteLine("Goose fly");
        }
    }
}